/*
 * Copyright 2009-2011 Collaborative Research Centre SFB 632 
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package annis.service.ifaces;

import java.io.Serializable;

/**
 * 
 * This is the actual container for a single search result.
 * 
 * 
 * 
 * @author k.huetter, b. weissenfels
 * 
 * 
 */
public interface AnnisBinary extends AnnisBinaryMetaData, Serializable, JSONAble
{

  public void setBytes(byte[] bytes);
  
  public byte[] getBytes();

  public void setLength(int length);

  public void setCorpusName(String corpusName);

  public void setMimeType(String mimeType);

  public void setFileName(String fileName);
}